#include <stdio.h>
#include "mpi.h"
#include <math.h>

float f(float x, float y);

void main(int argc, char** argv)
{
  int n;  /*How many inteval between*/
  float h;  /*step*/
  float x, y;  /*temp variable*/
  float StartX, StartY, EndX, EndY; /*starting and ending coordinates*/
  int Dimension[2];
  int coordinates[2], wrap_around[2];
  int p;  /*number of process*/
  int my_grid_rank;  
  int reorder = 1;
  MPI_Comm grid_comm;
  float pi2 = 0.0;  /*PI value each process calculate*/
  float pi[10];  
              /*used to store the PI values gather from process other than 0*/
  int i;  /*temp variable*/

  n = 1024;  
  h = (float)1/(float)n;
  wrap_around[0] = wrap_around[1] = 1;
  MPI_Init(&argc, &argv);
  MPI_Comm_size(MPI_COMM_WORLD, &p);
  Dimension[0]=Dimension[1] = (int)sqrt(p);

  MPI_Cart_create(MPI_COMM_WORLD, 2, Dimension, wrap_around,
     reorder, &grid_comm);
  MPI_Comm_rank(grid_comm, &my_grid_rank);
  MPI_Cart_coords(grid_comm, my_grid_rank, 2, coordinates);
  /* according to the coords in the Cart, derive the starting and ending
     coords in the area for this process */ 
  StartX = (float)coordinates[0] / (float)sqrt(p); 
  StartY = (float)coordinates[1] / (float)sqrt(p);
  EndX = (float)(coordinates[0]+1)/(float)sqrt(p);
  EndY = (float)(coordinates[1]+1)/(float)sqrt(p);

  for(x = StartX; x < EndX; x+=h)
     for(y = StartY; y < EndY; y+=h)
        pi2 += h * h *(f(x, y) + f(x, y+h)+ f(x+h, y) + f(x+h, y+h))/4;
  pi2 *= 16.0;

  MPI_Gather(&pi2, 1, MPI_FLOAT, pi, 1, MPI_FLOAT, 0, MPI_COMM_WORLD);
  
  if(my_grid_rank == 0)
  {  for(i = 1; i < p; i++)
       pi[0] += pi[i];
     printf("Final PI^2--->%25.16e\n", pi[0]);
  }
  MPI_Finalize();
}

float f(float x, float y)
{
   return ((float)1/((1 + x * x )*(1 + y * y)));
}
